.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include ConsoleOutput.inc

.code

start:
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax

	invoke	InitCommonControls

	invoke	DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke	ExitProcess,0

;########################################################################

AppendText	proc	pText:LPCTSTR
	invoke	GetWindowTextLength, hEditLog
	
	invoke	SendMessage, hEditLog, EM_SETSEL, eax, eax
	invoke	SendMessage, hEditLog, EM_REPLACESEL, TRUE, pText
	
	invoke	SendMessage, hEditLog, EM_GETLINECOUNT, 0, 0
	invoke	SendMessage, hEditLog, EM_LINESCROLL, 0, eax
	
	ret
AppendText	endp

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov	eax,uMsg
	.if	eax == WM_INITDIALOG
		invoke	GetDlgItem, hWin, IDE_LOG
		mov	hEditLog, eax

	.elseif eax == WM_COMMAND
		mov	edx, wParam
		movzx	eax, dx
		shr	edx, 16
		.if	edx == BN_CLICKED
			.if	eax == IDB_GO
				invoke	RtlZeroMemory, offset siChild, sizeof siChild
				invoke	RtlZeroMemory, offset piChild, sizeof piChild
				invoke	RtlZeroMemory, offset saChild, sizeof saChild
				
				;Create a pipe for the child's STDOUT.
				mov	saChild.nLength, sizeof SECURITY_ATTRIBUTES
				mov	saChild.bInheritHandle, TRUE
				mov	saChild.lpSecurityDescriptor, NULL
				
				invoke	CreatePipe, offset pipeReadHandle, offset pipeWriteHandle, offset saChild, 0
				.if	eax == 0
					invoke	MessageBox, hWin, SADD("CreatePipe"), 0, MB_ICONERROR
					jmp	@f
				.endif
				mov	bSuccess, eax
				
				;Set up members of STARTUPINFO structure.
				mov	siChild.cb, sizeof STARTUPINFO
				mov	siChild.dwFlags, STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES
				mov	siChild.wShowWindow, SW_HIDE
				push	pipeWriteHandle
				pop	siChild.hStdOutput
				push	pipeWriteHandle
				pop	siChild.hStdError
				
				;Create the child process.
				invoke	CreateProcess, NULL, 
						offset szCommand,
						NULL,				;pointer to process security attributes
						NULL,				;pointer to thread security attributes (use primary thread security attributes)
						TRUE,				;inherit handles
						0,				;creation flags
						NULL,				;pointer to new environment block (use parent's)
						offset szCurrentDirectory,	;pointer to current directory name
						offset siChild,			;pointer to STARTUPINFO
						offset piChild			;pointer to PROCESS_INFORMATION
				.if	eax == 0
					invoke	MessageBox, hWin, SADD("CreateProcess"), 0, MB_ICONERROR
					jmp	@f
				.endif
				
				.while	1
					mov	NumBytesRead, 0
					
					invoke	PeekNamedPipe, pipeReadHandle,		;handle to pipe to copy from
							offset PipeData,		;pointer to data buffer
							1,				;size, in bytes, of data buffer
							offset NumBytesRead,            ;pointer to number of bytes read   
							offset TotalBytesAvailable,	;pointer to total number of bytes available
							offset BytesLeftThisMessage	;pointer to unread bytes in this message
					.if	eax == 0
						invoke	MessageBox, hWin, SADD("PeekNamedPipe"), 0, MB_ICONERROR
						jmp	@f
					.endif
					
					.if	NumBytesRead > 0
						invoke	ReadFile, pipeReadHandle,
							offset PipeData,		;address of buffer that receives data
							BUF_SIZE - 1,			;number of bytes to read
							offset NumBytesRead,		;address of number of bytes read
							NULL				;address of structure for data for overlapped I/O
						.if	eax == 0
							invoke	MessageBox, hWin, SADD("ReadFile"), 0, MB_ICONERROR
							jmp	@f
						.endif
						
						
						;Zero-terminate the data.
						mov	ebx, NumBytesRead
						mov	esi, offset PipeData
						mov	byte ptr [esi+ebx], 0
						
						;Replace invalid characters
						mov	esi, offset PipeData
						mov	edi, offset szTemp
						.while	byte ptr [esi] != 0
							.if	byte ptr [esi] == 08h		;BACKSPACE
								mov	byte ptr [esi], 32
							.elseif	byte ptr [esi] == 0ah
								mov	byte ptr [edi], 0dh
								inc	edi 
							.endif
							movsb
						.endw
						mov	byte ptr [edi], 0
						
						invoke	lstrcpy, offset PipeData, offset szTemp
						
					comment %	
						//------------------------------------------------------------------
						//	If we're running a batch file that contains a pause command, 
						//	assume it is the last output from the batch file and remove it.
						//------------------------------------------------------------------
						TCHAR  *ptr = _tcsstr(PipeData, _T("Press any key to continue . . ."));
						if ( ptr )
						{
							*ptr = '\0';
						}
						%
						
						;Append the output to the CEdit control.
						invoke	AppendText, offset PipeData
						
						;Peek and pump messages.
					;;	PeekAndPump();
					.else
						;If the child process has completed, break out.
						invoke	WaitForSingleObject, piChild.hProcess, 0
						.if	eax == WAIT_OBJECT_0
							.break
						.endif
				comment %
						//------------------------------------------------------------------
						//	Peek and pump messages.
						//------------------------------------------------------------------
						PeekAndPump();
			
						//------------------------------------------------------------------
						//	If the user cancelled the operation, terminate the process.
						//------------------------------------------------------------------
						if ( m_bStopped )
						{
							Success = TerminateProcess
							(
								ProcessInfo.hProcess,
								0
							);
			
							if ( Success )
							{
								AppendText(_T("\r\nCancelled.\r\n\r\nProcess terminated successfully.\r\n"));
							}
							else
							{
								ShowLastError(_T("Error terminating process."));
							}
			
							break;
						}
			
						//------------------------------------------------------------------
						//	Sleep.
						//------------------------------------------------------------------
						Sleep(m_dwSleepMilliseconds);
						%
					.endif
				.endw
			@@:
			.endif
		.endif

	.elseif eax == WM_CLOSE
		invoke	EndDialog,hWin,0
	.else
		mov	eax,FALSE
		ret
	.endif

	mov	eax,TRUE
	ret
DlgProc endp

end start
